#include <Adafruit_NeoPixel.h>

Adafruit_NeoPixel pixels(16, 9, NEO_GRB + NEO_KHZ800);

const int r = 4;
const int s = A3;
const int b = 10;

void setup() {
  pinMode(r, OUTPUT);
  digitalWrite(r, LOW);
  pinMode(s, INPUT);
  pinMode(b, INPUT);
  pixels.begin();
  Serial.begin(9600);
  error(-2); // по экрану пробежит белая точка
  error(-1); // потом погасим экран
}

// -2 - бегущий огонек
// -1 - не светит
// 0 - зеленый
// x > 0 - красный с x яркими
void error(char e) {
  pixels.clear();
  switch (e) {
    case -2:
      for (byte i = 0; i < 16; i++) {
        pixels.clear();
        pixels.setPixelColor(i, pixels.Color(3, 3, 3));
        pixels.show();
        delay(75);
      }
      break;
    case -1: break;
    case 0:
      for (byte i = 0; i < 16; i++)
        pixels.setPixelColor(i, pixels.Color(0, 3, 0));
      break;
    default:
      for (byte i = 0; i < 16; i++)
        pixels.setPixelColor(i, pixels.Color(3, 0, 0));

      for (byte i = 0; i < e; i++)
        pixels.setPixelColor(i, pixels.Color(100, 0, 0));
      break;
  }
  pixels.show();
}

bool isInGap(int input, int num, int gap = 25){
  return (input > num - gap && input < num + gap);
}

int getAverage(int pin, int qua = 10){
  int mas[qua];
  for(int i = 0; i < qua; i++){
    mas[i] = analogRead(pin);
    delay(10);
  }
  
  uint32_t sum = 0;
  for(int i = 0; i < 10; i++){
    sum += mas[i];
  }
  return (sum / qua);
}

int test_tds(void) {
  error(-2);
  int temp = getAverage(s);
  Serial.println(temp);
  if(!isInGap(temp, 215)){
    return 1;
  }
  return 0;
}

void loop() {
  if (digitalRead(b) == 1) {
    while (digitalRead(b) == 1); // сработает по отпусканию кнопки

    error(-2); // по экрану пробежит белая точка
    error(-1); // потом погасим экран
    byte e = test_tds();
    if (e == 1) {
      error(1);  
      return;
    }
    if (e == 2) {
      error(2);  
      return;
    }
    error(0); // все хорошо - зеленый
  }

  delay(20);
}
